/* (C) 2009-2010 Yana */

#define YK0A_PREPROCESS_ONLY
#include "yk0a_mips.h"

#include "config.h"

#define VECTOR_TLB_FROM vector
#define VECTOR_TLB_SIZE 0x10
#define VECTOR_TLB_TO (0x80000000 | 0xa0000000)
#define VECTOR_OTHER_FROM vector
#define VECTOR_OTHER_SIZE 0x10
#define VECTOR_OTHER_TO (0x80000180 | 0xa0000000)

#define STATUS_KEEP (YK0A_MIPS_STATUS_IM_MASK | YK0A_MIPS_STATUS_ERL | YK0A_MIPS_STATUS_EXL)

#define OFFSET(a) ((a) * 4)

	.macro VECTOR_COPY from, size, to
	.set push
	.set reorder
	la $2, \from
	la $3, \to
	la $4, \from+\size
0:
	lw $5, ($2)
	sw $5, ($3)
	addiu $2, $2, 4
	addiu $3, $3, 4
	bne $2, $4, 0b
	.set pop
	.endm

	.global minix_stack
	.comm minix_stack, K_STACK_BYTES, YK0A_STACK_ALIGN

	.text
	.balign 4
	.set at
	.set reorder

vector:
	.set noat
	la $kt0, minix_exception_interrupt_procedure
	jr $kt0
	.set at

	.global MINIX
MINIX:
	move $6, $4

	VECTOR_COPY VECTOR_TLB_FROM, VECTOR_TLB_SIZE, VECTOR_TLB_TO
	VECTOR_COPY VECTOR_OTHER_FROM, VECTOR_OTHER_SIZE, VECTOR_OTHER_TO

	move $4, $6
	la $sp, minix_stack + K_STACK_BYTES / YK0A_STACK_ALIGN * YK0A_STACK_ALIGN - MINIX_ARGUMENT
	la $ra, minix_exception_interrupt_procedure_0
	la $2, glue_initialize
	jr $2

minix_exception_interrupt_procedure:
	.set noat
	la $kt0, proc_ptr
	lw $kt0, ($kt0)
	sw $at, OFFSET(1)($kt0)
	.set at
	sw $2, OFFSET(2)($kt0)
	sw $3, OFFSET(3)($kt0)
	sw $4, OFFSET(4)($kt0)
	sw $5, OFFSET(5)($kt0)
	sw $6, OFFSET(6)($kt0)
	sw $7, OFFSET(7)($kt0)
	sw $8, OFFSET(8)($kt0)
	sw $9, OFFSET(9)($kt0)
	sw $10, OFFSET(10)($kt0)
	sw $11, OFFSET(11)($kt0)
	sw $12, OFFSET(12)($kt0)
	sw $13, OFFSET(13)($kt0)
	sw $14, OFFSET(14)($kt0)
	sw $15, OFFSET(15)($kt0)
	sw $16, OFFSET(16)($kt0)
	sw $17, OFFSET(17)($kt0)
	sw $18, OFFSET(18)($kt0)
	sw $19, OFFSET(19)($kt0)
	sw $20, OFFSET(20)($kt0)
	sw $21, OFFSET(21)($kt0)
	sw $22, OFFSET(22)($kt0)
	sw $23, OFFSET(23)($kt0)
	sw $24, OFFSET(24)($kt0)
	sw $25, OFFSET(25)($kt0)
	sw $gp, OFFSET(28)($kt0)
	sw $sp, OFFSET(29)($kt0)
	sw $fp, OFFSET(30)($kt0)
	sw $ra, OFFSET(31)($kt0)
	mfhi $2
	mflo $3
	mfc0 $4, YK0A_MIPS_EPC
	mfc0 $5, YK0A_MIPS_STATUS
	sw $2, OFFSET(26)($kt0)
	sw $3, OFFSET(27)($kt0)
	sw $4, OFFSET(0)($kt0)
	sw $5, OFFSET(32)($kt0)
	la $sp, minix_stack + K_STACK_BYTES / YK0A_STACK_ALIGN * YK0A_STACK_ALIGN - MINIX_ARGUMENT
	la $2, glue_exception_interrupt_procedure
	jalr $2

minix_exception_interrupt_procedure_0:
	la $kt0, proc_ptr
	lw $kt0, ($kt0)
	lw $2, OFFSET(26)($kt0)
	lw $3, OFFSET(27)($kt0)
	lw $4, OFFSET(0)($kt0)
	lw $5, OFFSET(32)($kt0)
	mthi $2
	mtlo $3
	mtc0 $4, YK0A_MIPS_EPC
	YK0A_MIPS_HAZARD_EPC
	mfc0 $2, YK0A_MIPS_STATUS
	li $3, STATUS_KEEP
	and $2, $2, $3
	nor $3, $3, $0
	and $5, $5, $3
	or $2, $2, $5
	mtc0 $2, YK0A_MIPS_STATUS
	YK0A_MIPS_HAZARD_STATUS
	lw $2, OFFSET(2)($kt0)
	lw $3, OFFSET(3)($kt0)
	lw $4, OFFSET(4)($kt0)
	lw $5, OFFSET(5)($kt0)
	lw $6, OFFSET(6)($kt0)
	lw $7, OFFSET(7)($kt0)
	lw $8, OFFSET(8)($kt0)
	lw $9, OFFSET(9)($kt0)
	lw $10, OFFSET(10)($kt0)
	lw $11, OFFSET(11)($kt0)
	lw $12, OFFSET(12)($kt0)
	lw $13, OFFSET(13)($kt0)
	lw $14, OFFSET(14)($kt0)
	lw $15, OFFSET(15)($kt0)
	lw $16, OFFSET(16)($kt0)
	lw $17, OFFSET(17)($kt0)
	lw $18, OFFSET(18)($kt0)
	lw $19, OFFSET(19)($kt0)
	lw $20, OFFSET(20)($kt0)
	lw $21, OFFSET(21)($kt0)
	lw $22, OFFSET(22)($kt0)
	lw $23, OFFSET(23)($kt0)
	lw $24, OFFSET(24)($kt0)
	lw $25, OFFSET(25)($kt0)
	lw $gp, OFFSET(28)($kt0)
	lw $sp, OFFSET(29)($kt0)
	lw $fp, OFFSET(30)($kt0)
	lw $ra, OFFSET(31)($kt0)
	.set noat
	lw $at, OFFSET(1)($kt0)
	eret
	.set at
